diff -ruN qmail-1.03-orig/checkpassword.c qmail-1.03-ldap-20060201-orig/checkpassword.c
--- qmail-1.03-orig/checkpassword.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/checkpassword.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,291 @@
+/*
+ * Copyright (c) 1998-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/types.h>
+#include <unistd.h>
+#include "auth_mod.h"
+#include "auto_uids.h"
+#include "byte.h"
+#include "check.h"
+#include "env.h"
+#include "error.h"
+#include "fmt.h"
+#include "passwd.h"
+#include "pbsexec.h"
+#include "prot.h"
+#include "qldap.h"
+#include "qldap-debug.h"
+#include "qldap-errno.h"
+#include "qmail-ldap.h"
+#include "scan.h"
+#include "str.h"
+#include "stralloc.h"
+#ifdef QLDAP_CLUSTER
+#include "qldap-cluster.h"
+#endif
+
+#include "checkpassword.h"
+
+int
+check(checkfunc *f, stralloc *login, stralloc *authdata,
+    struct credentials *c, int fast)
+{
+	int	i, r;
+
+	for (i = 0; f[i] != 0; i++)
+		switch (r = f[i](login, authdata, c, fast)) {
+		case OK:
+		case FORWARD:
+			return r;
+		case NOSUCH:
+			/* lets try an other backend */
+			break;
+		case BADPASS:
+			/* NOTE: users defined in two dbs are not allowed */
+			return BADPASS;
+		default:
+			return r;
+		}
+	
+	return NOSUCH;
+}
+
+char num[FMT_ULONG];
+
+int
+check_ldap(stralloc *login, stralloc *authdata,
+    struct credentials *c, int fast)
+{
+	static	stralloc ld = {0};
+	qldap	*q;
+	char	*filter;
+	int	r, status, pwok, needforward;
+	unsigned long count, size, max;
+	const	char	*attrs[] = {
+				LDAP_UID, /* the first 10 attrs are default */
+				LDAP_QMAILUID,
+				LDAP_QMAILGID,
+				LDAP_ISACTIVE,
+				LDAP_MAILHOST,
+				LDAP_MAILSTORE,
+				LDAP_HOMEDIR,
+				LDAP_QUOTA_SIZE,
+				LDAP_QUOTA_COUNT,
+				LDAP_MAXMSIZE,
+				LDAP_PASSWD, 0}; /* passwd is extra */
+
+	/* TODO more debug output is needed */
+	needforward = 0;
+	q = qldap_new();
+	if (q == 0)
+		return ERRNO;
+	
+	r = qldap_open(q);
+	if (r != OK) goto fail;
+	r = qldap_bind(q, 0, 0);
+	if (r != OK) goto fail;
+	
+	if (fast) {
+		/* just comapre passwords and account status */
+		attrs[0] = LDAP_ISACTIVE;
+		if (qldap_need_rebind() == 0) {
+			attrs[1] = LDAP_PASSWD;
+			attrs[2] = 0;
+		} else
+			attrs[1] = 0;
+	} else {
+		if (qldap_need_rebind() != 0)
+			attrs[10] = 0;
+	}
+
+	filter = filter_uid(login->s);
+	if (filter == 0) { r = ERRNO; goto fail; }
+
+	r = qldap_lookup(q, filter, attrs);
+	if (r != OK) goto fail;
+
+	r = qldap_get_status(q, &status);
+	if (r != OK) goto fail;
+	if (status == STATUS_BOUNCE || status == STATUS_NOACCESS ||
+	    status == STATUS_DELETE) {
+		qldap_free(q);
+		return ACC_DISABLED;
+	}
+	
+	if (!fast) {
+#ifdef QLDAP_CLUSTER
+		r = qldap_get_attr(q, LDAP_MAILHOST, &c->forwarder,
+		    SINGLE_VALUE);
+		if (r != OK && r != NOSUCH) goto fail;
+		if (r == OK && cluster(c->forwarder.s) == 1) {
+			/* hostname is different, so I reconnect */
+			logit(8, "check_ldap: forwarding session to %s\n",
+			    c->forwarder.s);
+			needforward = 1;
+		}
+#endif
+
+		r = qldap_get_uid(q, &c->uid);
+		if (r != OK) goto fail;
+		r = qldap_get_gid(q, &c->gid);
+		if (r != OK) goto fail;
+		r = qldap_get_mailstore(q, &c->home, &c->maildir);
+		if (r != OK) goto fail;
+		if (!stralloc_0(&c->home) ||
+		    !stralloc_0(&c->maildir))
+			return ERRNO;
+		size = count = max = 0;
+		r = qldap_get_quota(q, &size, &count, &max);
+		if (r != OK) goto fail;
+		if (max != 0) {
+			num[fmt_ulong(num, max)] = 0;
+			if (!env_put2("DATASIZE", num))
+				auth_error(ERRNO);
+		}
+		if (size != 0 || count != 0) {
+			if (!stralloc_copys(&ld, "")) auth_error(ERRNO);
+			if (size != 0) {
+				if (!stralloc_catb(&ld, num,
+					    fmt_ulong(num, size)))
+					auth_error(ERRNO);
+				if (!stralloc_append(&ld, "S"))
+					auth_error(ERRNO);
+			}
+			if (count != 0) {
+				if (size != 0)
+					if (!stralloc_append(&ld, ","))
+						auth_error(ERRNO);
+				if (!stralloc_catb(&ld, num,
+					    fmt_ulong(num, count)))
+					auth_error(ERRNO);
+				if (!stralloc_append(&ld, "C"))
+					auth_error(ERRNO);
+			}
+			if (!stralloc_0(&ld)) auth_error(ERRNO);
+			if (!env_put2(ENV_QUOTA, ld.s )) auth_error(ERRNO);
+		}
+	}
+	
+	if (qldap_need_rebind() == 0) {
+		r = qldap_get_attr(q, LDAP_PASSWD, &ld, SINGLE_VALUE);
+		if (r != OK) goto fail;
+		pwok = cmp_passwd(authdata->s, ld.s);
+	} else {
+		r = qldap_get_dn(q, &ld);
+		if (r != OK) goto fail;
+		r = qldap_rebind(q, ld.s, authdata->s);
+		switch (r) {
+		case OK:
+			pwok = OK;
+			break;
+		case LDAP_BIND_AUTH:
+			pwok = BADPASS;
+			break;
+		default:
+			pwok = r;
+			break;
+		}
+	}
+	logit(32, "check_ldap: password compare was %s\n", 
+	    pwok == OK?"successful":"not successful");
+	qldap_free(q);
+	if (pwok == OK  && needforward == 1)
+		return FORWARD;
+	return pwok;
+fail:
+	qldap_free(q);
+	return r;
+	
+}
+
+void
+change_uid(unsigned int uid, unsigned int gid)
+{
+	unsigned int	id;
+	
+	id = geteuid();
+	if (id != 0 && (id == uid || uid == (unsigned int)-1)) {
+		/* not running as root so return */
+		logit(32, "change_uid: already running non root\n");
+		return;
+	}
+	if (uid == (unsigned int)-1 && gid == (unsigned int)-1) {
+		/* run as non-privileged user qmaild group nofiles */
+		uid = auto_uidd;
+		gid = auto_gidn;
+	}
+	/* first set the group id */
+	if (prot_gid(gid) == -1)
+		auth_error(ERRNO);
+	logit(32, "setgid succeeded (%i)\n", gid);
+	
+	/* ... then the user id */
+	if (prot_uid(uid) == -1)
+		auth_error(ERRNO);
+	logit(32, "setuid succeeded (%i)\n", uid);
+	
+	/* ... now check that we are realy not running as root */
+	if (!getuid())
+		auth_error(FAILED);
+}
+
+void
+setup_env(char *user, struct credentials *c)
+{
+	/* set up the environment for the execution of the subprogram */
+	if (!env_put2("USER", user))
+		auth_error(ERRNO);
+	
+	/* only courier-imap needs this but we set it anyway */
+	if (!env_put2("AUTHENTICATED", user))
+		auth_error(ERRNO);
+	
+	if (c->home.s != 0 && c->home.len > 0)
+		if (!env_put2("HOME", c->home.s))
+			auth_error(ERRNO);
+	
+	if (c->maildir.s != 0 && c->maildir.len > 0) {
+		if (!env_put2("MAILDIR", c->maildir.s))
+			auth_error(ERRNO);
+	} else {
+		if (!env_unset("MAILDIR"))
+			auth_error(ERRNO);
+	}
+	logit(32, "environment successfully set: "
+	    "USER %s, HOME %s, MAILDIR %s\n",
+	    user, c->home.s != 0 && c->home.len > 0?
+	    c->home.s:"unset, forwarding",
+	    c->maildir.s != 0 && c->maildir.len > 0?
+	    c->maildir.s:"unset, using aliasempty"); 
+}
+
diff -ruN qmail-1.03-orig/checkpassword.h qmail-1.03-ldap-20060201-orig/checkpassword.h
--- qmail-1.03-orig/checkpassword.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/checkpassword.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __CHECKPASSWORD_H__
+#define __CHECKPASSWORD_H__
+
+#include "stralloc.h"
+
+struct credentials {
+	unsigned int	uid;
+	unsigned int	gid;
+	stralloc	home;
+	stralloc	maildir;
+	stralloc	forwarder;
+};
+
+typedef int (*checkfunc)(stralloc *, stralloc *, struct credentials *, int);
+
+int check(checkfunc *, stralloc *, stralloc *, struct credentials *, int);
+int check_ldap(stralloc *, stralloc *, struct credentials *, int);
+void check_credentials(struct credentials *);
+void change_uid(unsigned int, unsigned int);
+void setup_env(char *, struct credentials *);
+
+#endif
diff -ruN qmail-1.03-orig/chkshsgr.c qmail-1.03-ldap-20060201-orig/chkshsgr.c
--- qmail-1.03-orig/chkshsgr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/chkshsgr.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,9 +1,12 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "exit.h"
-void main()
+
+int main(int argc, char ** argv)
 {
  short x[4];
 
  x[0] = x[1] = 0;
  if (getgroups(1,x) == 0) if (setgroups(1,x) == -1) _exit(1);
- _exit(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/chkspawn.c qmail-1.03-ldap-20060201-orig/chkspawn.c
--- qmail-1.03-orig/chkspawn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/chkspawn.c	2006-02-25 11:00:55.000000000 +0100
@@ -8,7 +8,7 @@
 char num[FMT_ULONG];
 fd_set fds;
 
-void main()
+int main(int argc, char **argv)
 {
   unsigned long hiddenlimit;
   unsigned long maxnumd;
@@ -22,8 +22,8 @@
     _exit(1);
   }
 
-  if (auto_spawn > 255) {
-    substdio_puts(subfderr,"Oops. You have set conf-spawn higher than 255.\n");
+  if (auto_spawn > 65000) {
+    substdio_puts(subfderr,"Oops. You have set conf-spawn higher than 65000.\n");
     substdio_flush(subfderr);
     _exit(1);
   }
@@ -44,5 +44,5 @@
     substdio_flush(subfderr);
     _exit(1);
   }
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/coe.h qmail-1.03-ldap-20060201-orig/coe.h
--- qmail-1.03-orig/coe.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/coe.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,6 @@
 #ifndef COE_H
 #define COE_H
 
-extern int coe();
+extern int coe(int);
 
 #endif
diff -ruN qmail-1.03-orig/commands.c qmail-1.03-ldap-20060201-orig/commands.c
--- qmail-1.03-orig/commands.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/commands.c	2006-02-25 11:00:55.000000000 +0100
@@ -11,6 +11,7 @@
 struct commands *c;
 {
   int i;
+  unsigned int n;
   char *arg;
 
   for (;;) {
@@ -28,13 +29,13 @@
 
     cmd.s[cmd.len] = 0;
 
-    i = str_chr(cmd.s,' ');
-    arg = cmd.s + i;
+    n = str_chr(cmd.s,' ');
+    arg = cmd.s + n;
     while (*arg == ' ') ++arg;
-    cmd.s[i] = 0;
+    cmd.s[n] = 0;
 
-    for (i = 0;c[i].text;++i) if (case_equals(c[i].text,cmd.s)) break;
-    c[i].fun(arg);
-    if (c[i].flush) c[i].flush();
+    for (n = 0;c[n].text;++n) if (case_equals(c[n].text,cmd.s)) break;
+    c[n].fun(arg);
+    if (c[n].flush) c[n].flush();
   }
 }
diff -ruN qmail-1.03-orig/commands.h qmail-1.03-ldap-20060201-orig/commands.h
--- qmail-1.03-orig/commands.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/commands.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,12 +1,14 @@
 #ifndef COMMANDS_H
 #define COMMANDS_H
 
+#include "substdio.h"
+
 struct commands {
-  char *text;
+  const char *text;
   void (*fun)();
   void (*flush)();
 } ;
 
-extern int commands();
+extern int commands(substdio *, struct commands *);
 
 #endif
diff -ruN qmail-1.03-orig/condredirect.c qmail-1.03-ldap-20060201-orig/condredirect.c
--- qmail-1.03-orig/condredirect.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/condredirect.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "sig.h"
 #include "readwrite.h"
 #include "exit.h"
@@ -23,12 +24,12 @@
 
 char inbuf[SUBSTDIO_INSIZE];
 char outbuf[1];
-substdio ssin = SUBSTDIO_FDBUF(read,0,inbuf,sizeof inbuf);
+substdio ssin = SUBSTDIO_FDBUF(subread,0,inbuf,sizeof inbuf);
 substdio ssout = SUBSTDIO_FDBUF(mywrite,-1,outbuf,sizeof outbuf);
 
 char num[FMT_ULONG];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -36,7 +37,7 @@
   char *dtline;
   int pid;
   int wstat;
-  char *qqx;
+  const char *qqx;
  
   if (!argv[1] || !argv[2])
     strerr_die1x(100,"condredirect: usage: condredirect newaddress program [ arg ... ]");
@@ -82,4 +83,6 @@
   qqx = qmail_close(&qqt);
   if (*qqx) strerr_die2x(*qqx == 'D' ? 100 : 111,FATAL,qqx + 1);
   strerr_die2x(99,"condredirect: qp ",num);
+  /* NOTREACHED */
+  return 1;
 }
diff -ruN qmail-1.03-orig/condwrite.c qmail-1.03-ldap-20060201-orig/condwrite.c
--- qmail-1.03-orig/condwrite.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/condwrite.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,509 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+/* based on qmail-local.c and condredirect.c by D. J. Bernstein */
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include "auto_qmail.h"
+#include "byte.h"
+#include "env.h"
+#include "error.h"
+#include "fmt.h"
+#include "getln.h"
+#include "gfrom.h"
+#include "lock.h"
+#include "maildir++.h"
+#include "now.h"
+#include "open.h"
+#include "qmail-ldap.h"
+#include "readwrite.h"
+#include "seek.h"
+#include "sig.h"
+#include "str.h"
+#include "stralloc.h"
+#include "strerr.h"
+#include "subfd.h"
+#include "substdio.h"
+#include "wait.h"
+#ifdef AUTOMAILDIRMAKE
+#include "mailmaker.h"
+#include "qldap-errno.h"
+#endif
+
+#define FATAL "condwrite: fatal: "
+
+void temp_nomem(void)
+{
+	strerr_die2x(111, FATAL, "Out of memory. (#4.3.0)");
+}
+
+void temp_rewind(void)
+{
+	strerr_die2x(111, FATAL, "Unable to rewind message. (#4.3.0)");
+}
+
+void temp_childcrashed(void)
+{
+	strerr_die2x(111, FATAL, "Aack, child crashed. (#4.3.0)");
+}
+
+void temp_fork(void)
+{
+	strerr_die4x(111, FATAL, "Unable to fork: ",
+	    error_str(errno), ". (#4.3.0)");
+}
+
+void
+temp_slowlock(void)
+{
+	strerr_die2x(111, FATAL,
+	    "File has been locked for 30 seconds straight. (#4.3.0)");
+}
+
+char		 fntmptph[80 + FMT_ULONG * 2];
+char		 fnnewtph[83 + FMT_ULONG * 3];
+
+void
+tryunlinktmp(void)
+{
+	unlink(fntmptph);
+}
+
+void
+sigalrm(void)
+{
+	tryunlinktmp();
+	_exit(3);
+}
+
+char		*quotastring;
+
+stralloc	 dtline = {0};
+stralloc	 rpline = {0};
+stralloc	 ufline = {0};
+stralloc	 messline = {0};
+
+char		 buf[1024];
+char		 outbuf[1024];
+int		 msfd = -1; /* global filedescriptor to the quota file */
+
+void
+maildir_child(char *dir)
+{
+	substdio	 ss, ssout;
+	struct stat	 st;
+	unsigned long	 pid, tnow;
+	char		 host[64];
+	char		*s;
+	int		 loop, fd;
+
+	sig_alarmcatch(sigalrm);
+	if (chdir(dir) == -1) {
+		if (error_temp(errno))
+			_exit(1);
+		else
+			_exit(2);
+	}
+
+	pid = getpid();
+	host[0] = 0;
+	gethostname(host, sizeof(host));
+	for (loop = 0;;++loop) {
+		tnow = now();
+		s = fntmptph;
+		s += fmt_str(s, "tmp/");
+		s += fmt_ulong(s, tnow); *s++ = '.';
+		s += fmt_ulong(s, pid); *s++ = '.';
+		s += fmt_strn(s, host, sizeof(host)); *s++ = 0;
+		if (stat(fntmptph, &st) == -1)
+			if (errno == error_noent)
+				break;
+		/* really should never get to this point */
+		if (loop == 2)
+			_exit(1);
+		sleep(2);
+	}
+	str_copy(fnnewtph, fntmptph);
+	byte_copy(fnnewtph, 3, "new");
+
+	alarm(86400);
+	fd = open_excl(fntmptph);
+	if (fd == -1)
+		_exit(1);
+
+	substdio_fdbuf(&ss, subread, 0, buf, sizeof(buf));
+	substdio_fdbuf(&ssout, subwrite, fd, outbuf, sizeof(outbuf));
+	if (substdio_put(&ssout, rpline.s, rpline.len) == -1) goto fail;
+	if (substdio_put(&ssout, dtline.s, dtline.len) == -1) goto fail;
+
+	switch(substdio_copy(&ssout, &ss)) {
+	case -2:
+		tryunlinktmp();
+		_exit(4);
+	case -3:
+		goto fail;
+	}
+
+	if (substdio_flush(&ssout) == -1) goto fail;
+	if (fsync(fd) == -1) goto fail;
+	if (fstat(fd, &st) == -1) goto fail;
+	if (close(fd) == -1) goto fail; /* NFS dorks */
+
+	s = fnnewtph;
+	while(*s) s++;
+	s += fmt_str(s,",S=");
+	s += fmt_ulong(s,(unsigned long)st.st_size);
+	*s++ = 0;
+
+	if(quotastring && *quotastring) {
+		/* finally update the quota file "maildirsize" */
+		quota_add(msfd, (unsigned long)st.st_size, 1);
+		close(msfd);
+	}
+
+	if (link(fntmptph, fnnewtph) == -1) goto fail;
+	/* if it was error_exist, almost certainly successful; i hate NFS */
+	tryunlinktmp();
+	_exit(0);
+
+fail:
+	tryunlinktmp();
+	_exit(1);
+}
+
+/* end child process */
+
+/* quota handling warning and bounce */
+void
+quota_bounce(const char *type)
+{
+	strerr_die4x(100, FATAL, "The users ", type,
+	    " is over the allowed quota (size). (#5.2.2)");
+}
+
+stralloc	qwapp = {0};
+
+void
+quota_warning(char *fn)
+{
+	char	*(args[3]);
+	int	 child, wstat;
+
+	if (!stralloc_copys(&qwapp, auto_qmail)) temp_nomem();
+	if (!stralloc_cats(&qwapp, "/bin/qmail-quotawarn")) temp_nomem();
+	if (!stralloc_0(&qwapp)) temp_nomem();
+
+	if (seek_begin(0) == -1) temp_rewind();
+
+	switch(child = fork()) {
+	case -1:
+		temp_fork();
+	case 0:
+		args[0] = qwapp.s; args[1] = fn; args[2] = 0;
+		sig_pipedefault();
+		execv(*args,args);
+		_exit(2);
+	}
+
+	wait_pid(&wstat,child);
+	if (wait_crashed(wstat))
+		temp_childcrashed();
+	switch(wait_exitcode(wstat)) {
+	case 2:
+		strerr_die6x(111, FATAL, "Unable to run quotawarn program: ",
+		    qwapp.s, ": ",error_str(errno),". (#4.2.2)");
+	case 111:
+		_exit(111);
+	case 0:
+		break;
+	default:
+		_exit(100);
+	}
+
+}
+
+/* end -- quota handling warning and bounce */
+
+void
+maildir_write(char *fn)
+{
+	struct stat	mailst;
+	quota_t		q;
+	unsigned long	mailsize;
+	int		child, wstat, perc;
+
+#ifdef AUTOMAILDIRMAKE
+	switch (maildir_make(fn)) {
+	case OK:
+		break;
+	case MAILDIR_CORRUPT:
+		strerr_die4x(111, FATAL, "The maildir '", fn,
+		    "' seems to be corrupted. (#4.2.1)");
+	case ERRNO:
+	default:
+		strerr_die4x(111, FATAL, "Unable to create maildir '",
+		    fn, "' (#4.3.0)");
+	}
+#endif
+
+	if (quotastring && *quotastring) {
+		if (fstat(0, &mailst) != 0)
+			strerr_die4x(111, FATAL,
+			    "Can not stat mail for quota: ",
+			    error_str(errno), ". (#4.3.0)");
+		mailsize = mailst.st_size;
+		quota_get(&q, quotastring);
+		if (quota_calc(fn, &msfd, &q) == -1) {
+			/* second chance */
+			sleep(3);
+			if (quota_calc(fn, &msfd, &q) == -1) {
+				strerr_die2x(111, FATAL,
+				    "Temporary race condition while "
+				    "calculating quota. (#4.3.0)");
+			}
+		}
+		/* fd can be -1, quota_add/rm take care of that */
+
+		if (quota_check(&q, mailsize, 1, &perc) != 0) { /* 0 if OK */
+			if (quota_recalc(fn, &msfd, &q) == -1) {
+				/* second chance */
+				sleep(3);
+				if (quota_recalc(fn, &msfd, &q) == -1)
+					strerr_die2x(111, FATAL,
+					    "Temporary race condition while "
+					    "recalculating quota. (#4.3.0)");
+			}
+			if (quota_check(&q, mailsize, 1, &perc) != 0) {
+				/* bounce mail but drop a warning first */
+				quota_warning(fn);
+				quota_bounce("mailfolder");
+			}
+		}
+		/* fd can be -1, quota_add/rm take care of that */
+
+		if (perc >= QUOTA_WARNING_LEVEL) 
+			/* drop a warning when mailbox is around 80% full */
+			quota_warning(fn);
+	}
+
+	/* end -- quota handling maildir */
+
+	if (seek_begin(0) == -1) temp_rewind();
+
+	switch(child = fork()) {
+	case -1:
+		temp_fork();
+	case 0:
+		maildir_child(fn);
+		_exit(111);
+	}
+
+	if (msfd != -1)
+		close(msfd);
+	/* close the maildirsize fd in the parent */
+
+	wait_pid(&wstat,child);
+	if (wait_crashed(wstat))
+		temp_childcrashed();
+	switch(wait_exitcode(wstat))
+	{
+	case 0:
+		/* we exit with 99 so no more deliveries are done */
+		_exit(99);
+	case 2:
+		strerr_die2x(111, FATAL,
+		    "Unable to chdir to maildir. (#4.2.1)");
+	case 3:
+		strerr_die2x(111, FATAL,
+		    "Timeout on maildir delivery. (#4.3.0)");
+	case 4:
+		strerr_die2x(111, FATAL, "Unable to read message. (#4.3.0)");
+	default:
+		strerr_die2x(111, FATAL,
+		    "Temporary error on maildir delivery. (#4.3.0)");
+	}
+}
+
+void
+mailfile(char *fn)
+{
+	substdio	ss, ssout;
+	struct stat	filest, mailst;
+	quota_t		q;
+	seek_pos	pos;
+	unsigned long	totalsize;
+	int		fd, match, flaglocked;
+
+	if(quotastring && *quotastring) {
+		quota_get(&q, quotastring);
+		if (stat(fn, &filest) == -1) {
+		 	/* size of nonexisting mailfile */
+			filest.st_size = 0;
+			if ( errno != error_noent)
+				strerr_die6x(111, FATAL, "Unable to quota ", fn,
+				    ": ",error_str(errno), ". (#4.3.0)");
+		}
+		if (fstat(0, &mailst) != 0)
+			strerr_die4x(111, FATAL, "Unable to quota mail: ",
+			    error_str(errno), ". (#4.3.0)");
+
+		totalsize = (unsigned long)filest.st_size +
+		    (unsigned long)mailst.st_size;
+		if (totalsize * 100 / q.quota_size >= QUOTA_WARNING_LEVEL)
+			/* drop a warning when mailbox is around 80% full */
+			quota_warning(fn);
+		if (totalsize > q.quota_size)
+			quota_bounce("mailbox");
+	}
+
+	/* end -- quota handling mbox */
+
+	if (seek_begin(0) == -1) temp_rewind();
+
+	fd = open_append(fn);
+	if (fd == -1)
+		strerr_die6x(111, FATAL, "Unable to open ",fn,": ",
+		    error_str(errno),". (#4.2.1)");
+
+	sig_alarmcatch(temp_slowlock);
+	alarm(30);
+	flaglocked = (lock_ex(fd) != -1);
+	alarm(0);
+	sig_alarmdefault();
+
+	seek_end(fd);
+	pos = seek_cur(fd);
+
+	substdio_fdbuf(&ss, subread, 0, buf, sizeof(buf));
+	substdio_fdbuf(&ssout, subwrite, fd, outbuf, sizeof(outbuf));
+	if (substdio_put(&ssout, ufline.s, ufline.len)) goto writeerrs;
+	if (substdio_put(&ssout, rpline.s, rpline.len)) goto writeerrs;
+	if (substdio_put(&ssout, dtline.s, dtline.len)) goto writeerrs;
+
+	for (;;) {
+		if (getln(&ss, &messline, &match, '\n') != 0) {
+			strerr_warn4(FATAL, "Unable to read message: ",
+			    error_str(errno),". (#4.3.0)",0);
+			if (flaglocked)
+				seek_trunc(fd, pos);
+			close(fd);
+			_exit(111);
+		}
+		if (!match && !messline.len) break;
+		if (gfrom(messline.s, messline.len))
+			if (substdio_bput(&ssout, ">", 1)) goto writeerrs;
+		if (substdio_bput(&ssout, messline.s, messline.len))
+			goto writeerrs;
+		if (!match) {
+			if (substdio_bputs(&ssout, "\n")) goto writeerrs;
+			break;
+		}
+	}
+	if (substdio_bputs(&ssout, "\n")) goto writeerrs;
+	if (substdio_flush(&ssout)) goto writeerrs;
+	if (fsync(fd) == -1) goto writeerrs;
+	close(fd);
+	_exit(99);
+
+writeerrs:
+	strerr_warn6(FATAL, "Unable to write ", fn, ": ",
+	    error_str(errno), ". (#4.3.0)",0);
+	if (flaglocked) seek_trunc(fd, pos);
+	close(fd);
+	_exit(111);
+}
+
+int main(int argc, char **argv)
+{
+	char	*s;
+	int	 pid, wstat;
+
+	if (!env_init()) temp_nomem();
+	if (!argv[1] || !argv[2])
+		strerr_die1x(100,"condwrite: usage: "
+		    "condwrite {maildir/|mailfile} program [ arg ... ]");
+
+	if ((s = env_get("RPLINE"))) { 
+		if (!stralloc_copys(&rpline, s)) temp_nomem();
+	} else
+		strerr_die2x(100, FATAL, "RPLINE not present.");
+
+	if ((s = env_get("DTLINE"))) {
+		if (!stralloc_copys(&dtline, s)) temp_nomem();
+	} else
+		strerr_die2x(100, FATAL, "DTLINE not present.");
+
+	if ((s = env_get("UFLINE"))) {
+		if (!stralloc_copys(&ufline, s)) temp_nomem();
+	} else
+		strerr_die2x(100, FATAL, "UFLINE not present.");
+
+	pid = fork();
+	if (pid == -1)
+		temp_fork();
+	if (pid == 0) {
+		execvp(argv[2],argv + 2);
+		if (error_temp(errno)) _exit(111);
+		_exit(100);
+	}
+
+	if (wait_pid(&wstat,pid) == -1)
+		strerr_die2x(111,FATAL,"wait failed");
+	if (wait_crashed(wstat))
+		temp_childcrashed();
+
+	switch(wait_exitcode(wstat)) {
+	case 0:
+		break;
+	case 111:
+		strerr_die2x(111,FATAL,"temporary child error");
+	default:
+		  _exit(0);
+	}
+
+	if (seek_begin(0) == -1)
+		temp_rewind();
+	sig_pipeignore();
+
+	/* quota, dotmode and forwarding handling - part 1 */
+	/* setting the quota */
+	quotastring = env_get(ENV_QUOTA);
+ 
+	if(argv[1][str_len(argv[1]) - 1] == '/')
+		maildir_write(argv[1]);
+	else
+		mailfile(argv[1]);
+
+	return (100);
+}
diff -ruN qmail-1.03-orig/conf-spawn qmail-1.03-ldap-20060201-orig/conf-spawn
--- qmail-1.03-orig/conf-spawn	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/conf-spawn	2006-02-25 11:00:55.000000000 +0100
@@ -1,4 +1,4 @@
-120
+500
 
 This is a silent concurrency limit. You can't set it above 255. On some
 systems you can't set it above 125. qmail will refuse to compile if the
diff -ruN qmail-1.03-orig/constmap.c qmail-1.03-ldap-20060201-orig/constmap.c
--- qmail-1.03-orig/constmap.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/constmap.c	2006-02-25 11:00:55.000000000 +0100
@@ -3,8 +3,8 @@
 #include "case.h"
 
 static constmap_hash hash(s,len)
-char *s;
-int len;
+const char *s;
+unsigned int len;
 {
   unsigned char ch;
   constmap_hash h;
@@ -18,10 +18,10 @@
   return h;
 }
 
-char *constmap(cm,s,len)
+const char *constmap(cm,s,len)
 struct constmap *cm;
-char *s;
-int len;
+const char *s;
+unsigned int len;
 {
   constmap_hash h;
   int pos;
@@ -39,28 +39,29 @@
 
 int constmap_init(cm,s,len,flagcolon)
 struct constmap *cm;
-char *s;
-int len;
+const char *s;
+unsigned int len;
 int flagcolon;
 {
-  int i;
-  int j;
-  int k;
+  unsigned int i;
+  unsigned int j;
+  unsigned int k;
   int pos;
   constmap_hash h;
  
   cm->num = 0;
   for (j = 0;j < len;++j) if (!s[j]) ++cm->num;
+  if (cm->num < 0) return 0;
  
   h = 64;
-  while (h && (h < cm->num)) h += h;
+  while (h && (h < cm->num)) h += h; /* XXX why is num an int */
   cm->mask = h - 1;
  
   cm->first = (int *) alloc(sizeof(int) * h);
   if (cm->first) {
-    cm->input = (char **) alloc(sizeof(char *) * cm->num);
+    cm->input = (const char **) alloc(sizeof(char *) * cm->num);
     if (cm->input) {
-      cm->inputlen = (int *) alloc(sizeof(int) * cm->num);
+      cm->inputlen = (unsigned int *) alloc(sizeof(unsigned int) * cm->num);
       if (cm->inputlen) {
         cm->hash = (constmap_hash *) alloc(sizeof(constmap_hash) * cm->num);
         if (cm->hash) {
@@ -111,4 +112,5 @@
   alloc_free(cm->inputlen);
   alloc_free(cm->input);
   alloc_free(cm->first);
+  cm->num = 0;
 }
diff -ruN qmail-1.03-orig/constmap.h qmail-1.03-ldap-20060201-orig/constmap.h
--- qmail-1.03-orig/constmap.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/constmap.h	2006-02-25 11:00:55.000000000 +0100
@@ -9,12 +9,12 @@
   constmap_hash *hash;
   int *first;
   int *next;
-  char **input;
-  int *inputlen;
+  const char **input;
+  unsigned int *inputlen;
 } ;
 
-extern int constmap_init();
-extern void constmap_free();
-extern char *constmap();
+extern int constmap_init(struct constmap *, const char *, unsigned int, int);
+extern void constmap_free(struct constmap *);
+extern const char *constmap(struct constmap *, const char *, unsigned int);
 
 #endif
